﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Malovani
{
    public partial class Window : Form
    {
        private Color initColor = Color.Yellow;

        public Window()
        {
            InitializeComponent();
            pictureBox.Image = new Bitmap
                (pictureBox.Width, pictureBox.Height);


            Graphics g = Graphics.FromImage (pictureBox.Image);
            Brush b = new SolidBrush (initColor);
            g.FillRectangle (b, 0, 0, pictureBox.Width, pictureBox.Height);
        }

        private void testMenu_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage(pictureBox.Image);
            Pen p  = new Pen (Color.Red);
            p.Width = 3;
            g.DrawLine (p, 10, 10, 100, 100);
            pictureBox.Invalidate ();
        }

        private void quitMenu_Click(object sender, EventArgs e)
        {
            Close ();
        }

        int X0, Y0;
        bool stisk = false;
        Bitmap save;

        private void pictureBox_MouseDown(object sender, 
                                          MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisk = true;
            save = new Bitmap (pictureBox.Image);
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage (save, 0, 0);
                Pen p = new Pen (Color.Blue);
                g.DrawLine(p, X0, Y0, e.X, e.Y);
                pictureBox.Invalidate();
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
               Graphics g = Graphics.FromImage(pictureBox.Image);
               g.DrawImage (save, 0, 0);
               Pen p = new Pen(Color.Blue);
               p.Width = 3;
               if (e.Button == MouseButtons.Right)
               {
                   int X = X0;
                   int Y = Y0;
                   int W = e.X - X0;
                   int H = e.Y - Y0;
                   if (W < 0) { X += W; W = -W; }
                   if (H < 0) { Y += H; H = -H; }
                   g.DrawRectangle(p, X, Y, W, H);
               }
               else if (e.Button == MouseButtons.Middle)
                   g.DrawEllipse(p, X0, Y0, e.X - X0, e.Y - Y0);
               else 
                   g.DrawLine(p, X0, Y0, e.X, e.Y);
               pictureBox.Invalidate();
               stisk = false;
               save = null;
            }
        }

        private void pictureBox_Resize(object sender, EventArgs e)
        {
        }

        private static int max(int a, int b)
        {
            return a > b ? a : b;
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Size s1 = pictureBox.Size;
            Size s2 = pictureBox.Image.Size;
            int W = max(s1.Width, s2.Width);
            int H = max(s1.Height, s2.Height);
            Bitmap b = new Bitmap(W, H);

            Graphics g = Graphics.FromImage(b);
            Brush br = new SolidBrush(initColor);
            g.FillRectangle(br, 0, 0, pictureBox.Width, pictureBox.Height);
            g.DrawImage(pictureBox.Image, 0, 0);
            pictureBox.Image = b;
        }

    }
}
